/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include "oo7.h"

// collection to hold composite parts, atomic parts, and connections
persistent collection <dbvoid> CompPartSet;

// collection for atomic parts, no longer allocated from CompPartSet
persistent collection <AtomicPart> AtomicPartSet;

// collection to hold documents
persistent collection <Document> DocumentSet;

// collection to hold manuals
persistent collection <Manual> ManualSet;

// collection to hold modules and their assemblies
persistent collection <dbvoid> ModuleSet;

// AllParts is an extent of all atomic parts
persistent collection <dbvoid> AllPartsCol; 
// persistent dbclass Assoc  AllParts(&AllPartsCol);

// AllModules is an extent of all modules
persistent collection <dbvoid> AllModulesCol; 
persistent dbclass Assoc  AllModules(&AllModulesCol);

// AllDocuments is an extent of all documents
persistent collection <dbvoid> AllDocumentsCol; 
persistent dbclass Assoc  AllDocuments(&AllDocumentsCol);

// AllCompParts is an extent of all composite parts
persistent collection <dbvoid> AllCompPartsCol;
persistent dbclass Assoc  AllCompParts(&AllCompPartsCol);

// index mapping atomic part ids to atomic parts
persistent dbclass IntBtIndex*  AtomicPartIdx; 

// index mapping composite part ids to composite parts
persistent dbclass IntBtIndex*  CompPartIdx; 

// index mapping document titles to documents
persistent dbclass StringBtIndex*  DocumentIdx; 

// index mapping document ids to documents
persistent dbclass IntBtIndex*  DocumentIdIdx; 

// index mapping assembly ids to base assemblies
persistent dbclass IntBtIndex*  BaseAssemblyIdx; 

// index mapping module names to modules
persistent dbclass StringBtIndex*  ModuleIdx;

// DummySet is an extent used to hold dummy objects
persistent collection<dbvoid> DummySetCol;
persistent dbclass Assoc  DummySet(&DummySetCol);
